
loadstring(hc.get_global('CM_COMMON'))()

-- local Hits = hc.get_global('CM_HITS')
local _CM_Options, iParsers, users = hc.get_global('CM_OPTIONS'), hc.get_global('CM_iPARSERS'), UpdateHits()

local ews = ''
_CM_Options.LanguageID = hc.language_id	--    
hc.set_global_table_item('CM_OPTIONS', 'LanguageID', _CM_Options.LanguageID)
local LocalCodePage = _CM_Options.SystemCoding
if not LocalCodePage then
	hc.put_msg('Content Master\r\n\r\nCan\'t determine system code page. Unable to show settings dialog.\r\nPlease send followed string to author:\r\n\r\n', os.setlocale(nil, 'all'))
	return
end
local lng = PrepareLanguage(_CM_Options.LanguageID, 'utf')
ews = ews .. ' function PrepareLanguage() ' .. SaveTable(lng) .. ' end'
-- ews = ews .. ' CM_DIR = [[' .. CM_DIR .. ']]'
ews = ews .. ' CM_UpdateCfgURL = [[' .. CM_UpdateCfgURL .. ']]'

local function RecodeTree(user)	--   wxLua    
	user.RecodedName = hc.recode(user.Name, LocalCodePage, 65001)
	for _,v in ipairs(user) do RecodeTree(v) end
end
RecodeTree(users.ALL)

RecalcHits(users.ALL)
local usersTable = SaveTable(users)
_CM_WriteFile(hc.script_name:match('.*%.') .. 'ini', 'wb', usersTable)

ews = ews .. ' function GetUsers() ' .. usersTable .. ' end'
ews = ews .. ' function Get_iParsers() ' .. iParsers .. ' end'
ews = ews .. ' function GetVersion() return [[' .. _CM_Options.Version .. ']] end'

_CM_WriteFile(CM_DIR .. 'workers\\cm_tmp.lua', 'wb', ews)
hc.execute_and_wait(CM_DIR .. 'wxLuaFreeze.exe "' .. CM_DIR .. 'options_gui.lua"')
xpcall(function() return dofile(CM_DIR .. 'workers\\cm_tmp.lua') end, function() return { ALL={ Name='ALL', Parsers={} } } end)
if _CM_Update then
	_CM_Update = nil
	hc.send_request('GET ' .. CM_UpdateCfgURL .. ' HTTP/1.1\r\nCMUpdate:\r\nConnection: close\r\n\r\n')
end
if _CM_Saved then
	hc.set_global('CM_USERS', _CM_ReadFile(hc.script_name:match('.*%.') .. 'ini'))
	Destroy()
	Init()
	_CM_Saved = nil
-- else hc.set_global('CM_USERS', _CM_ReadFile(hc.script_name:match('.*%.') .. 'ini'))
end
